import string
import commands

class GenericHelp(object):
    def help(self):
        s = """Usage: backup-convert <global-options> <command> <command-arguments>.

Global options:

  -v|--verbose  Enables verbose processing.

Commands:\n"""

        for (name, class_) in commands.items():
            s += "  " + string.ljust(name, 14)  + class_.SHORT_HELP_STRING + "\n"

        s += "\n'backup-convert help <command>' describes <command> in details\n"
        return s

    help = classmethod(help)

class HelpCommand(commands.HelpProvider):
    def __init__(self, globalOptions):
        pass

    USAGE_STRING = "help [<command>|select-objects]"
    SHORT_HELP_STRING = "Shows help message"
    HELP_STRING = """Shows the help message about command line structure or specific command.

'help' without arguments shows command line structure.
'help <command>' describes specific command in details.
"""

    def parse(self, args):
        self.command = self._parseForCommand(args)

    def _parseForCommand(self, args):
        if len(args) == 0:
            return GenericHelp
        if len(args) == 1:
            return commands.get(args[0])
        raise RuntimeError("Too many arguments for 'help' command")

    def act(self):
        print self.command.help()

commands.register("help", HelpCommand, 100)

# Local Variables:
# mode: python
# indent-tabs-mode: nil
# tab-width: 4
# End:
