#!/usr/bin/env python

#
# Generated Thu Dec  9 08:58:31 2010 by generateDS.py.
#

import sys
import getopt
from string import lower as str_lower
from xml.dom import minidom
from xml.dom import Node

#
# If you have installed IPython you can uncomment and use the following.
# IPython is available from http://ipython.scipy.org/.
#

## from IPython.Shell import IPShellEmbed
## args = ''
## ipshell = IPShellEmbed(args,
##     banner = 'Dropping into IPython',
##     exit_msg = 'Leaving Interpreter, back to program.')

# Then use the following line where and when you want to drop into the
# IPython shell:
#    ipshell('<some message> -- Entering ipshell.\nHit Ctrl-D to exit')

#
# Support/utility functions.
#

def showIndent(outfile, level):
    for idx in range(level):
        outfile.write('    ')

def quote_xml(inStr):
    s1 = (isinstance(inStr, basestring) and inStr or
          '%s' % inStr)
    s1 = s1.replace('&', '&amp;')
    s1 = s1.replace('<', '&lt;')
    s1 = s1.replace('>', '&gt;')
    return s1

def quote_attrib(inStr):
    s1 = (isinstance(inStr, basestring) and inStr or
          '%s' % inStr)
    s1 = s1.replace('&', '&amp;')
    s1 = s1.replace('"', '&quot;')
    s1 = s1.replace('<', '&lt;')
    s1 = s1.replace('>', '&gt;')
    return s1

def quote_python(inStr):
    s1 = inStr
    if s1.find("'") == -1:
        if s1.find('\n') == -1:
            return "'%s'" % s1
        else:
            return "'''%s'''" % s1
    else:
        if s1.find('"') != -1:
            s1 = s1.replace('"', '\\"')
        if s1.find('\n') == -1:
            return '"%s"' % s1
        else:
            return '"""%s"""' % s1


class MixedContainer:
    # Constants for category:
    CategoryNone = 0
    CategoryText = 1
    CategorySimple = 2
    CategoryComplex = 3
    # Constants for content_type:
    TypeNone = 0
    TypeText = 1
    TypeString = 2
    TypeInteger = 3
    TypeFloat = 4
    TypeDecimal = 5
    TypeDouble = 6
    TypeBoolean = 7
    def __init__(self, category, content_type, name, value):
        self.category = category
        self.content_type = content_type
        self.name = name
        self.value = value
    def getCategory(self):
        return self.category
    def getContenttype(self, content_type):
        return self.content_type
    def getValue(self):
        return self.value
    def getName(self):
        return self.name
    def export(self, outfile, level, name):
        if self.category == MixedContainer.CategoryText:
            outfile.write(self.value)
        elif self.category == MixedContainer.CategorySimple:
            self.exportSimple(outfile, level, name)
        else:    # category == MixedContainer.CategoryComplex
            self.value.export(outfile, level, name)
    def exportSimple(self, outfile, level, name):
        if self.content_type == MixedContainer.TypeString:
            outfile.write('<%s>%s</%s>' % (self.name, self.value, self.name))
        elif self.content_type == MixedContainer.TypeInteger or \
                self.content_type == MixedContainer.TypeBoolean:
            outfile.write('<%s>%d</%s>' % (self.name, self.value, self.name))
        elif self.content_type == MixedContainer.TypeFloat or \
                self.content_type == MixedContainer.TypeDecimal:
            outfile.write('<%s>%f</%s>' % (self.name, self.value, self.name))
        elif self.content_type == MixedContainer.TypeDouble:
            outfile.write('<%s>%g</%s>' % (self.name, self.value, self.name))
    def exportLiteral(self, outfile, level, name):
        if self.category == MixedContainer.CategoryText:
            showIndent(outfile, level)
            outfile.write('MixedContainer(%d, %d, "%s", "%s"),\n' % \
                (self.category, self.content_type, self.name, self.value))
        elif self.category == MixedContainer.CategorySimple:
            showIndent(outfile, level)
            outfile.write('MixedContainer(%d, %d, "%s", "%s"),\n' % \
                (self.category, self.content_type, self.name, self.value))
        else:    # category == MixedContainer.CategoryComplex
            showIndent(outfile, level)
            outfile.write('MixedContainer(%d, %d, "%s",\n' % \
                (self.category, self.content_type, self.name,))
            self.value.exportLiteral(outfile, level + 1)
            showIndent(outfile, level)
            outfile.write(')\n')


class _MemberSpec(object):
    def __init__(self, name='', data_type='', container=0):
        self.name = name
        self.data_type = data_type
        self.container = container
    def set_name(self, name): self.name = name
    def get_name(self): return self.name
    def set_data_type(self, data_type): self.data_type = data_type
    def get_data_type(self): return self.data_type
    def set_container(self, container): self.container = container
    def get_container(self): return self.container


#
# Data representation classes.
#

class ExecutionResult:
    subclass = None
    superclass = None
    def __init__(self, status=None, log_location='', message=None, object=None):
        self.status = status
        self.log_location = log_location
        if message is None:
            self.message = []
        else:
            self.message = message
        if object is None:
            self.object = []
        else:
            self.object = object
    def factory(*args_, **kwargs_):
        if ExecutionResult.subclass:
            return ExecutionResult.subclass(*args_, **kwargs_)
        else:
            return ExecutionResult(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_message(self): return self.message
    def set_message(self, message): self.message = message
    def add_message(self, value): self.message.append(value)
    def insert_message(self, index, value): self.message[index] = value
    def get_object(self): return self.object
    def set_object(self, object): self.object = object
    def add_object(self, value): self.object.append(value)
    def insert_object(self, index, value): self.object[index] = value
    def get_status(self): return self.status
    def set_status(self, status): self.status = status
    def get_log_location(self): return self.log_location
    def set_log_location(self, log_location): self.log_location = log_location
    def export(self, outfile, level, namespace_='', name_='ExecutionResult'):
        showIndent(outfile, level)
        outfile.write('<%s%s' % (namespace_, name_))
        self.exportAttributes(outfile, level, namespace_, name_='ExecutionResult')
        outfile.write('>\n')
        self.exportChildren(outfile, level + 1, namespace_, name_)
        showIndent(outfile, level)
        outfile.write('</%s%s>\n' % (namespace_, name_))
    def exportAttributes(self, outfile, level, namespace_='', name_='ExecutionResult'):
        outfile.write(' status="%s"' % str(self.get_status()))
        if self.get_log_location() is not None:
            outfile.write(' log-location="%s"' % (quote_attrib(self.get_log_location()), ))
    def exportChildren(self, outfile, level, namespace_='', name_='ExecutionResult'):
        for message_ in self.get_message():
            message_.export(outfile, level, namespace_, name_='message')
        for object_ in self.get_object():
            object_.export(outfile, level, namespace_, name_='object')
    def exportLiteral(self, outfile, level, name_='ExecutionResult'):
        level += 1
        self.exportLiteralAttributes(outfile, level, name_)
        self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, name_):
        showIndent(outfile, level)
        outfile.write('status = "%s",\n' % (self.get_status(),))
        showIndent(outfile, level)
        outfile.write('log_location = "%s",\n' % (self.get_log_location(),))
    def exportLiteralChildren(self, outfile, level, name_):
        showIndent(outfile, level)
        outfile.write('message=[\n')
        level += 1
        for message in self.message:
            showIndent(outfile, level)
            outfile.write('MessageType(\n')
            message.exportLiteral(outfile, level, name_='message')
            showIndent(outfile, level)
            outfile.write('),\n')
        level -= 1
        showIndent(outfile, level)
        outfile.write('],\n')
        showIndent(outfile, level)
        outfile.write('object=[\n')
        level += 1
        for object in self.object:
            showIndent(outfile, level)
            outfile.write('ObjectType(\n')
            object.exportLiteral(outfile, level, name_='object')
            showIndent(outfile, level)
            outfile.write('),\n')
        level -= 1
        showIndent(outfile, level)
        outfile.write('],\n')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        if attrs.get('status'):
            self.status = attrs.get('status').value
        if attrs.get('log-location'):
            self.log_location = attrs.get('log-location').value
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'message':
            obj_ = MessageType.factory()
            obj_.build(child_)
            self.message.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'object':
            obj_ = ObjectType.factory()
            obj_.build(child_)
            self.object.append(obj_)
# end class ExecutionResult


class ObjectType:
    subclass = None
    superclass = None
    def __init__(self, typexx='', name='', object=None, message=None):
        self.typexx = typexx
        self.name = name
        if object is None:
            self.object = []
        else:
            self.object = object
        if message is None:
            self.message = []
        else:
            self.message = message
    def factory(*args_, **kwargs_):
        if ObjectType.subclass:
            return ObjectType.subclass(*args_, **kwargs_)
        else:
            return ObjectType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_object(self): return self.object
    def set_object(self, object): self.object = object
    def add_object(self, value): self.object.append(value)
    def insert_object(self, index, value): self.object[index] = value
    def get_message(self): return self.message
    def set_message(self, message): self.message = message
    def add_message(self, value): self.message.append(value)
    def insert_message(self, index, value): self.message[index] = value
    def get_type(self): return self.typexx
    def set_type(self, typexx): self.typexx = typexx
    def get_name(self): return self.name
    def set_name(self, name): self.name = name
    def export(self, outfile, level, namespace_='', name_='ObjectType'):
        showIndent(outfile, level)
        outfile.write('<%s%s' % (namespace_, name_))
        self.exportAttributes(outfile, level, namespace_, name_='ObjectType')
        outfile.write('>\n')
        self.exportChildren(outfile, level + 1, namespace_, name_)
        showIndent(outfile, level)
        outfile.write('</%s%s>\n' % (namespace_, name_))
    def exportAttributes(self, outfile, level, namespace_='', name_='ObjectType'):
        outfile.write(' type="%s"' % (quote_attrib(self.get_type()), ))
        outfile.write(' name="%s"' % (quote_attrib(self.get_name()), ))
    def exportChildren(self, outfile, level, namespace_='', name_='ObjectType'):
        for object_ in self.get_object():
            object_.export(outfile, level, namespace_, name_='object')
        for message_ in self.get_message():
            message_.export(outfile, level, namespace_, name_='message')
    def exportLiteral(self, outfile, level, name_='ObjectType'):
        level += 1
        self.exportLiteralAttributes(outfile, level, name_)
        self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, name_):
        showIndent(outfile, level)
        outfile.write('typexx = "%s",\n' % (self.get_type(),))
        showIndent(outfile, level)
        outfile.write('name = "%s",\n' % (self.get_name(),))
    def exportLiteralChildren(self, outfile, level, name_):
        showIndent(outfile, level)
        outfile.write('object=[\n')
        level += 1
        for object in self.object:
            showIndent(outfile, level)
            outfile.write('ObjectType(\n')
            object.exportLiteral(outfile, level, name_='object')
            showIndent(outfile, level)
            outfile.write('),\n')
        level -= 1
        showIndent(outfile, level)
        outfile.write('],\n')
        showIndent(outfile, level)
        outfile.write('message=[\n')
        level += 1
        for message in self.message:
            showIndent(outfile, level)
            outfile.write('MessageType(\n')
            message.exportLiteral(outfile, level, name_='message')
            showIndent(outfile, level)
            outfile.write('),\n')
        level -= 1
        showIndent(outfile, level)
        outfile.write('],\n')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        if attrs.get('type'):
            self.typexx = attrs.get('type').value
        if attrs.get('name'):
            self.name = attrs.get('name').value
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'object':
            obj_ = ObjectType.factory()
            obj_.build(child_)
            self.object.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'message':
            obj_ = MessageType.factory()
            obj_.build(child_)
            self.message.append(obj_)
# end class ObjectType


class MessageType:
    subclass = None
    superclass = None
    def __init__(self, code='', severity='', context='', file='', line='', text='', message=None):
        self.code = code
        self.severity = severity
        self.context = context
        self.file = file
        self.line = line
        self.text = text
        self.message = message
    def factory(*args_, **kwargs_):
        if MessageType.subclass:
            return MessageType.subclass(*args_, **kwargs_)
        else:
            return MessageType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_context(self): return self.context
    def set_context(self, context): self.context = context
    def get_file(self): return self.file
    def set_file(self, file): self.file = file
    def get_line(self): return self.line
    def set_line(self, line): self.line = line
    def get_text(self): return self.text
    def set_text(self, text): self.text = text
    def get_message(self): return self.message
    def set_message(self, message): self.message = message
    def get_code(self): return self.code
    def set_code(self, code): self.code = code
    def get_severity(self): return self.severity
    def set_severity(self, severity): self.severity = severity
    def export(self, outfile, level, namespace_='', name_='MessageType'):
        showIndent(outfile, level)
        outfile.write('<%s%s' % (namespace_, name_))
        self.exportAttributes(outfile, level, namespace_, name_='MessageType')
        outfile.write('>\n')
        self.exportChildren(outfile, level + 1, namespace_, name_)
        showIndent(outfile, level)
        outfile.write('</%s%s>\n' % (namespace_, name_))
    def exportAttributes(self, outfile, level, namespace_='', name_='MessageType'):
        outfile.write(' code="%s"' % (quote_attrib(self.get_code()), ))
        if self.get_severity() is not None:
            outfile.write(' severity="%s"' % (quote_attrib(self.get_severity()), ))
    def exportChildren(self, outfile, level, namespace_='', name_='MessageType'):
        if self.get_context() != None :
            if self.get_context() != "" :
                showIndent(outfile, level)
                outfile.write('<%scontext>%s</%scontext>\n' % (namespace_, quote_xml(self.get_context()), namespace_))
        if self.get_file() != None :
            if self.get_file() != "" :
                showIndent(outfile, level)
                outfile.write('<%sfile>%s</%sfile>\n' % (namespace_, quote_xml(self.get_file()), namespace_))
        if self.get_line() != None :
            if self.get_line() != "" :
                showIndent(outfile, level)
                outfile.write('<%sline>%s</%sline>\n' % (namespace_, quote_xml(self.get_line()), namespace_))
        showIndent(outfile, level)
        outfile.write('<%stext>%s</%stext>\n' % (namespace_, quote_xml(self.get_text()), namespace_))
        if self.get_message() != None :
            if self.message:
                self.message.export(outfile, level, namespace_, name_='message')
    def exportLiteral(self, outfile, level, name_='MessageType'):
        level += 1
        self.exportLiteralAttributes(outfile, level, name_)
        self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, name_):
        showIndent(outfile, level)
        outfile.write('code = "%s",\n' % (self.get_code(),))
        showIndent(outfile, level)
        outfile.write('severity = "%s",\n' % (self.get_severity(),))
    def exportLiteralChildren(self, outfile, level, name_):
        showIndent(outfile, level)
        outfile.write('context=%s,\n' % quote_python(self.get_context()))
        showIndent(outfile, level)
        outfile.write('file=%s,\n' % quote_python(self.get_file()))
        showIndent(outfile, level)
        outfile.write('line=%s,\n' % quote_python(self.get_line()))
        showIndent(outfile, level)
        outfile.write('text=%s,\n' % quote_python(self.get_text()))
        if self.message:
            showIndent(outfile, level)
            outfile.write('message=MessageType(\n')
            self.message.exportLiteral(outfile, level, name_='message')
            showIndent(outfile, level)
            outfile.write('),\n')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        if attrs.get('code'):
            self.code = attrs.get('code').value
        if attrs.get('severity'):
            self.severity = attrs.get('severity').value
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'context':
            context_ = ''
            for text__content_ in child_.childNodes:
                context_ += text__content_.nodeValue
            self.context = context_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'file':
            file_ = ''
            for text__content_ in child_.childNodes:
                file_ += text__content_.nodeValue
            self.file = file_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'line':
            line_ = ''
            for text__content_ in child_.childNodes:
                line_ += text__content_.nodeValue
            self.line = line_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'text':
            text_ = ''
            for text__content_ in child_.childNodes:
                text_ += text__content_.nodeValue
            self.text = text_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'message':
            obj_ = MessageType.factory()
            obj_.build(child_)
            self.set_message(obj_)
# end class MessageType


from xml.sax import handler, make_parser

class SaxStackElement:
    def __init__(self, name='', obj=None):
        self.name = name
        self.obj = obj
        self.content = ''

#
# SAX handler
#
class Sax_ExecutionResultHandler(handler.ContentHandler):
    def __init__(self):
        self.stack = []
        self.root = None

    def getRoot(self):
        return self.root

    def setDocumentLocator(self, locator):
        self.locator = locator
    
    def showError(self, msg):
        print '*** (showError):', msg
        sys.exit(-1)

    def startElement(self, name, attrs):
        done = 0
        if name == 'ExecutionResult':
            obj = ExecutionResult.factory()
            stackObj = SaxStackElement('ExecutionResult', obj)
            self.stack.append(stackObj)
            done = 1
        elif name == 'message':
            obj = MessageType.factory()
            stackObj = SaxStackElement('message', obj)
            self.stack.append(stackObj)
            done = 1
        elif name == 'object':
            obj = ObjectType.factory()
            stackObj = SaxStackElement('object', obj)
            self.stack.append(stackObj)
            done = 1
        elif name == 'context':
            stackObj = SaxStackElement('context', None)
            self.stack.append(stackObj)
            done = 1
        elif name == 'file':
            stackObj = SaxStackElement('file', None)
            self.stack.append(stackObj)
            done = 1
        elif name == 'line':
            stackObj = SaxStackElement('line', None)
            self.stack.append(stackObj)
            done = 1
        elif name == 'text':
            stackObj = SaxStackElement('text', None)
            self.stack.append(stackObj)
            done = 1
        if not done:
            self.reportError('"%s" element not allowed here.' % name)

    def endElement(self, name):
        done = 0
        if name == 'ExecutionResult':
            if len(self.stack) == 1:
                self.root = self.stack[-1].obj
                self.stack.pop()
                done = 1
        elif name == 'message':
            if len(self.stack) >= 2:
                self.stack[-2].obj.add_message(self.stack[-1].obj)
                self.stack.pop()
                done = 1
        elif name == 'object':
            if len(self.stack) >= 2:
                self.stack[-2].obj.add_object(self.stack[-1].obj)
                self.stack.pop()
                done = 1
        elif name == 'context':
            if len(self.stack) >= 2:
                content = self.stack[-1].content
                self.stack[-2].obj.set_context(content)
                self.stack.pop()
                done = 1
        elif name == 'file':
            if len(self.stack) >= 2:
                content = self.stack[-1].content
                self.stack[-2].obj.set_file(content)
                self.stack.pop()
                done = 1
        elif name == 'line':
            if len(self.stack) >= 2:
                content = self.stack[-1].content
                self.stack[-2].obj.set_line(content)
                self.stack.pop()
                done = 1
        elif name == 'text':
            if len(self.stack) >= 2:
                content = self.stack[-1].content
                self.stack[-2].obj.set_text(content)
                self.stack.pop()
                done = 1
        if not done:
            self.reportError('"%s" element not allowed here.' % name)

    def characters(self, chrs, start, end):
        if len(self.stack) > 0:
            self.stack[-1].content += chrs[start:end]

    def reportError(self, mesg):
        locator = self.locator
        sys.stderr.write('Doc: %s  Line: %d  Column: %d\n' % \
            (locator.getSystemId(), locator.getLineNumber(), 
            locator.getColumnNumber() + 1))
        sys.stderr.write(mesg)
        sys.stderr.write('\n')
        sys.exit(-1)
        #raise RuntimeError

USAGE_TEXT = """
Usage: python <Parser>.py [ -s ] <in_xml_file>
Options:
    -s        Use the SAX parser, not the minidom parser.
"""

def usage():
    print USAGE_TEXT
    sys.exit(-1)


#
# SAX handler used to determine the top level element.
#
class SaxSelectorHandler(handler.ContentHandler):
    def __init__(self):
        self.topElementName = None
    def getTopElementName(self):
        return self.topElementName
    def startElement(self, name, attrs):
        self.topElementName = name
        raise StopIteration


def parseSelect(inFileName):
    infile = file(inFileName, 'r')
    topElementName = None
    parser = make_parser()
    documentHandler = SaxSelectorHandler()
    parser.setContentHandler(documentHandler)
    try:
        try:
            parser.parse(infile)
        except StopIteration:
            topElementName = documentHandler.getTopElementName()
        if topElementName is None:
            raise RuntimeError, 'no top level element'
        topElementName = topElementName.replace('-', '_').replace(':', '_')
        if topElementName not in globals():
            raise RuntimeError, 'no class for top element: %s' % topElementName
        topElement = globals()[topElementName]
        infile.seek(0)
        doc = minidom.parse(infile)
    finally:
        infile.close()
    rootNode = doc.childNodes[0]
    rootObj = topElement.factory()
    rootObj.build(rootNode)
    # Enable Python to collect the space used by the DOM.
    doc = None
    sys.stdout.write('<?xml version="1.0" ?>\n')
    rootObj.export(sys.stdout, 0)
    return rootObj


def saxParse(inFileName):
    parser = make_parser()
    documentHandler = Sax_ExecutionResultHandler()
    parser.setDocumentHandler(documentHandler)
    parser.parse('file:%s' % inFileName)
    root = documentHandler.getRoot()
    sys.stdout.write('<?xml version="1.0" ?>\n')
    root.export(sys.stdout, 0)
    return root


def saxParseString(inString):
    parser = make_parser()
    documentHandler = Sax_ExecutionResultHandler()
    parser.setDocumentHandler(documentHandler)
    parser.feed(inString)
    parser.close()
    rootObj = documentHandler.getRoot()
    #sys.stdout.write('<?xml version="1.0" ?>\n')
    #rootObj.export(sys.stdout, 0)
    return rootObj


def parse(inFileName):
    doc = minidom.parse(inFileName)
    rootNode = doc.documentElement
    rootObj = ExecutionResult.factory()
    rootObj.build(rootNode)
    # Enable Python to collect the space used by the DOM.
    doc = None
    sys.stdout.write('<?xml version="1.0" ?>\n')
    rootObj.export(sys.stdout, 0, name_="ExecutionResult")
    return rootObj


def parseString(inString):
    doc = minidom.parseString(inString)
    rootNode = doc.documentElement
    rootObj = ExecutionResult.factory()
    rootObj.build(rootNode)
    # Enable Python to collect the space used by the DOM.
    doc = None
    sys.stdout.write('<?xml version="1.0" ?>\n')
    rootObj.export(sys.stdout, 0, name_="ExecutionResult")
    return rootObj


def parseLiteral(inFileName):
    doc = minidom.parse(inFileName)
    rootNode = doc.documentElement
    rootObj = ExecutionResult.factory()
    rootObj.build(rootNode)
    # Enable Python to collect the space used by the DOM.
    doc = None
    sys.stdout.write('from execution_result import *\n\n')
    sys.stdout.write('rootObj = ExecutionResult(\n')
    rootObj.exportLiteral(sys.stdout, 0, name_="ExecutionResult")
    sys.stdout.write(')\n')
    return rootObj


def main():
    args = sys.argv[1:]
    if len(args) == 2 and args[0] == '-s':
        saxParse(args[1])
    elif len(args) == 1:
        parse(args[0])
    else:
        usage()


if __name__ == '__main__':
    main()
    #import pdb
    #pdb.run('main()')

