import pmm_config
import subproc


class SuspendHandler:
    def run(session_id, logger = None):
        cmd = subproc.CmdLine(pmm_config.plesk_runner())
        for plesk_runner_arg in pmm_config.plesk_runner_args():
            cmd.arg(plesk_runner_arg)
        cmd.arg(pmm_config.pmm_suspend_handler())
        cmd.arg('unsuspend-all')
        cmd.arg(session_id)
        try:
            cmd.spawn()
        except subproc.NonzeroExitException, x:
            errcode = x.exitcode
            message =  u"suspend handler error (Error code = " + unicode(errcode) + "):"  \
                     + u"\n== STDOUT ====================\n" + x.subprocess.stdout + u"\n==============================\n" \
                     + u"== STDERR ====================\n" + x.subprocess.stderr + u"\n==============================\n"
            if logger:
                logger(u"suspend handler error: " + message)

    run = staticmethod(run)

