import os
import sys
import logging

import osutil
import subproc

import pmm_config
import pmmcli_exceptions


mswindows = (sys.platform == "win32")


_logger = logging.getLogger("pmmcli.daemon")


class PMMCliDaemon:
    def __init__(self):
        pass

    def __get_pmmcli_daemon_pid(self):
        pid = ''
        pid_value = None
        try:
            pidfile = open(os.path.join(pmm_config.pmmcli_dir(),'pmmcli_daemon.pid'))
        except IOError:
            return None
        try:
            pid = pidfile.read( )
        finally:
            pidfile.close()
        try:
            pid_value = int(pid)
        except:
            pass
        return pid_value

    def __start(self):
        _logger.debug("starting pmmcli daemon...")
        cmd = subproc.AsyncCmdLine(pmm_config.daemon())
        for arg in pmm_config.daemon_args():
            cmd.arg(arg)
        try:
            cmd.asyncSpawn()
        except subproc.AsyncExecuteException, x:
            _logger.error(u"exception raised while invoke 'migration-handler' utility: %s" % unicode(x))
            _logger.error("could not start PMMCli daemon process")

    def start(self):
        _logger.debug("detecting running pmmcli daemon...")
        pid = self.__get_pmmcli_daemon_pid()
        if not pid or not osutil.is_active(pid):
            self.__start()
            return True
        else:
            _logger.debug("pmmcli daemon is running")
        return False

