class StopProcessing(Exception):
    pass

def walkBackup(b, visitor):
    try:
        metadata = b.getMetadata()

        visitor.visitMetadata(metadata)

        for (contentId, bundle) in b.getContents():
            visitor.visitBundle(contentId, bundle)

        return visitor.saveMetadata(metadata, b.isSigned())

    except StopProcessing:
        pass        

# Local Variables:
# mode: python
# indent-tabs-mode: nil
# tab-width: 4
# End:                     
