from urllib2 import urlopen, Request
from urllib2 import HTTPPasswordMgrWithDefaultRealm, AbstractBasicAuthHandler
from urllib2 import HTTPBasicAuthHandler, install_opener, build_opener
from ClientForm import HTMLForm, FileControl
from encoder import EncoderFile
from cStringIO import StringIO
import base64

#
# Hack to overcome problem with urllib2.AbstractBasicAuthHandler
# (https://sourceforge.net/tracker/index.php?func=detail&aid=1378679&group_id=5470&atid=105470)
#

AbstractBasicAuthHandler._old_retry_http_basic_auth = AbstractBasicAuthHandler.retry_http_basic_auth

def fixed_retry_http_basic_auth(self, host, req, realm):
    user, pw = self.passwd.find_user_password(realm, req.get_full_url())
    if pw is not None:
        raw = "%s:%s" % (user, pw)
        auth = 'Basic %s' % base64.encodestring(raw).strip()
        if req.headers.get(self.auth_header, None) == auth:
            return None
        req.add_header(self.auth_header, auth)
        return self.parent.open(req)
    else:
        return None

AbstractBasicAuthHandler.retry_http_basic_auth = fixed_retry_http_basic_auth

#
# End of hack
#

#
# Hack to overcome problem with older API-RPC versions
# (http://bugs.plesk.ru/show_bug.cgi?id=75359)
#
# Original Request.add_header is not used here due to the fact
# Python2.2 does not properly capitalize headers, so we have to
# capitalize it manually.
#

def fixed_add_header(self, key, val):
    if key == "HTTP_AUTH_LOGIN" or key == "HTTP_AUTH_PASSWD":
        self.headers[key] = val
    else:
        self.headers[key.capitalize()] = val

Request.add_header = fixed_add_header

#
# End of hack
#

class ApiRpcClient(object):
    METHOD = "POST"
    PORT = "8443"
    PROTO_VERSION = "1.4.0.0"
    URL = "/enterprise/control/agent.php"
    SCHEMA = "https"
    FORM_CONTENT_TYPE = "multipart/form-data"

    def getAgentUrl(self):
        return self.getFullUrl(ApiRpcClient.URL)

    def getFullUrl(self, url):
        return ApiRpcClient.SCHEMA + "://" + self.host + ":" + ApiRpcClient.PORT + url

    def __init__(self, host, login, password):
        self.host = host
        self.login = login
        self.password = password

    def doRequest(self, request):
        request.add_header('HTTP_AUTH_LOGIN', self.login)
        request.add_header('HTTP_AUTH_PASSWD', self.password)

        response = urlopen(request)

        return response

    def packetRequest(self, packet):
        request = Request(self.getAgentUrl())
        packet.setVersion(ApiRpcClient.PROTO_VERSION)

        packet_str = StringIO()
        body = EncoderFile(packet_str, "utf-8")
        body.write('<?xml version="1.0" encoding="UTF-8"?>')
        packet.export(body, 0, name_ = 'packet')

        request.add_data(packet_str.getvalue())
        request.add_header('Content-Type', 'text/xml')

        return request

    def fileUploadRequest(self, file):
        form = HTMLForm(self.getAgentUrl(), ApiRpcClient.METHOD, ApiRpcClient.FORM_CONTENT_TYPE)
        upload = FileControl("agentfile", "agentfile", {})
        upload.add_file(file, filename="agentfile")
        upload.add_to_form(form)
        request = form.click()

        return request

    def openFile(self, url, user, password):
        passman = HTTPPasswordMgrWithDefaultRealm()
        passman.add_password(None, self.getFullUrl(url), user, password)
        install_opener(build_opener(HTTPBasicAuthHandler(passman)))

        return self.doRequest(Request(self.getFullUrl(url)))
